package cn.ibizlab.businesscentral.core.odoo_snailmail.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_snailmail.domain.Snailmail_letter;
import cn.ibizlab.businesscentral.core.odoo_snailmail.filter.Snailmail_letterSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Snailmail_letterMapper extends BaseMapper<Snailmail_letter>{

    Page<Snailmail_letter> searchDefault(IPage page, @Param("srf") Snailmail_letterSearchContext context, @Param("ew") Wrapper<Snailmail_letter> wrapper) ;
    @Override
    Snailmail_letter selectById(Serializable id);
    @Override
    int insert(Snailmail_letter entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Snailmail_letter entity);
    @Override
    int update(@Param(Constants.ENTITY) Snailmail_letter entity, @Param("ew") Wrapper<Snailmail_letter> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Snailmail_letter> selectByCompanyId(@Param("id") Serializable id) ;

    List<Snailmail_letter> selectByPartnerId(@Param("id") Serializable id) ;

    List<Snailmail_letter> selectByCreateUid(@Param("id") Serializable id) ;

    List<Snailmail_letter> selectByUserId(@Param("id") Serializable id) ;

    List<Snailmail_letter> selectByWriteUid(@Param("id") Serializable id) ;


}
